Name:		efl
Version:	1.12.2
Release:	1%{?dist}
Summary:	Collection of Enlightenment libraries
License:	BSD and LGPLv2+ and GPLv2 and zlib
URL:		http://enlightenment.org/
Source0:	http://download.enlightenment.org/rel/libs/efl/efl-%{version}.tar.bz2
Patch0:		efl-1.11.4-tslibfix.patch
BuildRequires:	bullet-devel libpng-devel libjpeg-devel gstreamer1-devel zlib-devel
BuildRequires:	gstreamer1-plugins-base-devel luajit-devel libtiff-devel openssl-devel
BuildRequires:	curl-devel dbus-devel glibc-devel fontconfig-devel freetype-devel
BuildRequires:	fribidi-devel pulseaudio-libs-devel libsndfile-devel libX11-devel
BuildRequires:	libXau-devel libXcomposite-devel libXdamage-devel libXdmcp-devel
BuildRequires:	libXext-devel libXfixes-devel libXinerama-devel libXrandr-devel
BuildRequires:	libXrender-devel libXScrnSaver-devel libXtst-devel libXcursor-devel
BuildRequires:	libXp-devel libXi-devel mesa-libGL-devel mesa-libEGL-devel
BuildRequires:	libblkid-devel libmount-devel systemd-devel harfbuzz-devel 
BuildRequires:	libwebp-devel scim-devel tslib-devel SDL2-devel SDL-devel c-ares-devel
BuildRequires:	doxygen, systemd, libwayland-client-devel giflib-devel
BuildRequires:	mesa-libwayland-egl-devel
BuildRequires:	autoconf, automake, libtool, gettext-devel
# EFL is kindof a metapackage. Almost. 
Requires:	ecore%{?_isa} = %{version}-%{release}
Requires:	edje%{?_isa} = %{version}-%{release}
Requires:	eet%{?_isa} = %{version}-%{release}
Requires:	eeze%{?_isa} = %{version}-%{release}
Requires:	efreet%{?_isa} = %{version}-%{release}
Requires:	eina%{?_isa} = %{version}-%{release}
Requires:	eio%{?_isa} = %{version}-%{release}
Requires:	eldbus%{?_isa} = %{version}-%{release}
Requires:	elua%{?_isa} = %{version}-%{release}
Requires:	embryo%{?_isa} = %{version}-%{release}
Requires:	emotion%{?_isa} = %{version}-%{release}
Requires:	eo%{?_isa} = %{version}-%{release}
Requires:	eolian%{?_isa} = %{version}-%{release}
Requires:	ephysics%{?_isa} = %{version}-%{release}
Requires:	ethumb%{?_isa} = %{version}-%{release}
Requires:	evas%{?_isa} = %{version}-%{release}

%description
EFL is a collection of libraries for handling many common tasks a
developer may have such as data structures, communication, rendering,
widgets and more.

%package devel
Summary:	Development files for EFL
Requires:	efl%{?_isa} = %{version}-%{release}
Requires:	ecore-devel%{?_isa} = %{version}-%{release}
Requires:	edje-devel%{?_isa} = %{version}-%{release}
Requires:	eet-devel%{?_isa} = %{version}-%{release}
Requires:	eeze-devel%{?_isa} = %{version}-%{release}
Requires:	efreet-devel%{?_isa} = %{version}-%{release}
Requires:	eina-devel%{?_isa} = %{version}-%{release}
Requires:	eio-devel%{?_isa} = %{version}-%{release}
Requires:	eldbus-devel%{?_isa} = %{version}-%{release}
Requires:	embryo-devel%{?_isa} = %{version}-%{release}
Requires:	emotion-devel%{?_isa} = %{version}-%{release}
Requires:	eo-devel%{?_isa} = %{version}-%{release}
Requires:	eolian-devel%{?_isa} = %{version}-%{release}
Requires:	ephysics-devel%{?_isa} = %{version}-%{release}
Requires:	ethumb-devel%{?_isa} = %{version}-%{release}
Requires:	evas-devel%{?_isa} = %{version}-%{release}

%description devel
Development files for EFL.

%package -n ecore
Summary:	Enlightenment core main-loop, system events and execution layer
License:	BSD

%description -n ecore
Ecore is the core main-loop, system events and execution layer. This
handles running the main loop, integrating with external data and
timing sources (the system clock, file descriptors, system signals),
and producing an event queue, walking that queue and dispatching
events to appropriate callbacks.

It also includes audio support, a completely event-based TCP/UDP and 
Unix domain socket API (Con), glue between the display target and evas,
raw input and framebuffer handling, file access convenience APIs, an 
input method abstraction framework, IPC support, X and Wayland support.

%package -n ecore-devel
Summary:	Development files for ecore
License:	BSD
Requires:	ecore%{?_isa} = %{version}-%{release}
Requires:	pkgconfig

%description -n ecore-devel
The ecore-devel package contains libraries and header files for
developing applications that use ecore.

%package -n edje
Summary:	Abstract GUI layout and animation object library
License:	GPLv2+ and BSD

%description -n edje
Abstract GUI layout and animation object library.

%package -n edje-devel
Summary:	Edje headers, documentation and test programs
Requires:	edje%{?_isa} = %{version}-%{release}
Requires:	pkgconfig

%description -n edje-devel
Headers,  test programs and documentation for edje.

%package -n eet
Summary:	Library for speedy data storage, retrieval, and compression
License:	GPLv2+ and BSD

%description -n eet
Eet is a tiny library designed to write an arbitary set of chunks of
data to a file and optionally compress each chunk (very much like a
zip file) and allow fast random-access reading of the file later
on. It does not do zip as a zip itself has more complexity than is
needed, and it was much simpler to implement this once here.

It also can encode and decode data structures in memory, as well as
image data for saving to eet files or sending across the network to
other machines, or just writing to arbitary files on the system. All
data is encoded in a platform independent way and can be written and
read by any architecture.

%package -n eet-devel
Summary:	Development files for eet
License:	GPLv2+ and BSD
Requires:	eet%{?_isa} = %{version}-%{release}
Requires:	pkgconfig

%description -n eet-devel
The eet-devel package contains libraries and header files for
developing applications that use eet.

%package -n eeze
Summary:	Device abstraction library
License:	BSD and GPLv2+

%description -n eeze
Eeze is a library for manipulating devices through udev with a simple and fast
api. It interfaces directly with libudev, avoiding such middleman daemons as
udisks/upower or hal, to immediately gather device information the instant it
becomes known to the system.

%package -n eeze-devel
Summary:	Development files for eeze
Requires:	eeze%{?_isa} = %{version}-%{release}
Requires:	pkgconfig

%description -n eeze-devel
Headers, test programs and documentation for eeze.

%package -n efreet
Summary:		Library for handling Freedesktop.org standards
License:		BSD
Requires(post):		systemd
Requires(preun):	systemd
Requires(postun):	systemd

%description -n efreet
This library provides code for handling Freedesktop.org standards such
as .desktop files, XDG Menus, Icon search paths and more. It provides
a central daemon to handle monitoring for changes that the library
talks to, and the daemon handles updating local cache files the
library reads.

%package -n efreet-devel
Summary:	Development files for efreet
Requires:	efreet%{?_isa} = %{version}-%{release}
Requires:	pkgconfig

%description -n efreet-devel
Development files for efreet.

%package -n eina
Summary:	Data Type Library
License:	LGPLv2+
Provides:	libeina%{?_isa} = %{version}-%{release}
Obsoletes:	libeina <= 1.7.10

%description -n eina
Eina is a library that provides optimized data types
and useful tools for projects.

%package -n eina-devel
Summary:	Eina headers, documentation and test programs
License:	LGPLv2+
Provides:	libeina-devel%{?_isa} = %{version}-%{release}
Obsoletes:	libeina-devel <= 1.7.10
Requires:	eina%{?_isa} = %{version}-%{release}
Requires:	pkgconfig

%description -n eina-devel
Headers, test programs and documentation for libeina.

%package -n eio
Summary:	Asynchronous I/O library
License:	LGPLv2+

%description -n eio
An asynchronous I/O library for doing disk I/O without blocking.

%package -n eio-devel
Summary:	Development files for eio
Requires:	eio%{?_isa} = %{version}-%{release}
Requires:	pkgconfig

%description -n eio-devel
Development files for eio.

%package -n eldbus
Summary:	DBus access library
License:	LGPLv2+

%description -n eldbus
This is a DBus access library to allow you to create DBus services as
well as clients. This glues in DBus into the main-loop so all access is
asynchronous.

%package -n eldbus-devel
Summary:	Development files for eldbus
Requires:	eldbus%{?_isa} = %{version}-%{release}
Requires:	pkgconfig

%description -n eldbus-devel
Development files for eldbus.

%package -n elua
Summary:	Enlightenment Lua support
License:	BSD

%description -n elua
Enlightenment Lua support.

%package -n embryo
Summary:	Small Pawn based virtual machine and compiler
License:	zlib

%description -n embryo
This is a small C-like language compiler and byte-code interpreter
library. This is used for scripting in Edje. The code is based on
original source from the Pawn/Small Language but has been made
portable (endianess issues fixed) and 64bit issues fixed, with the
runtime library being refactored to be extremely small.

%package -n embryo-devel
Summary:	Development files for embryo
Requires:	embryo%{?_isa} = %{version}-%{release}
Requires:	pkgconfig

%description -n embryo-devel
Development files for embryo.

%package -n emotion
Summary:	Media Library for EFL
License:	GPLv2+ and BSD

%description -n emotion
This is a wrapper around Gstreamer and/or Xine and/or external
pluggable decoder binaries (generic binaries provided by Emotion
Generic Players or any suitable drop-in replacement). This glues in
the decoder library, and its output into a smart Evas object that will
display the playback for you as the video plays, as well as providing
higher level controls to seek, play, pause and query the stream
regardless of the back-end used.

%package -n emotion-devel
Summary:	Development files for emotion
Requires:	emotion%{?_isa} = %{version}-%{release}
Requires:	pkgconfig

%description -n emotion-devel
Development files for emotion.

%package -n eo
Summary:	Core object system API for EFL
License:	BSD

%description -n eo
This is a core object system API that EFL 1.8 and on depend on. The
API is not finalized, so do not depend on it yet in EFL 1.8, but
future EFL versions will lock it down.

This object system does simple and multiple inheritance, refcounting,
strong and weak references, auto-deletion of child objects, unifies
callback handling with a single path, and also abstracts object
pointers to be indirect table lookups for increased safety at runtime.

%package -n eo-devel
Summary:	Development files for EO
Requires:	eo%{?_isa} = %{version}-%{release}
Requires:	pkgconfig

%description -n eo-devel
Development files for EO.

%package -n eolian
Summary:	EO object parser and code generator
License:	BSD

%description -n eolian
EO object parser and code generator.

%package -n eolian-devel
Summary:	Development files for eolian
Requires:	eolian%{?_isa} = %{version}-%{release}

%description -n eolian-devel
Development files for eolian.

%package -n ephysics
Summary:	EFL wrapper library for Bullet physics
License:	BSD

%description -n ephysics
This library provides a wrapper around the Bullet physics library,
allowing for it to be linked directly with Evas objects and control
their behavior as if they were real physical objects.

%package -n ephysics-devel
Summary:	Development files for ephysics
Requires:	ephysics%{?_isa} = %{version}-%{release}
Requires:	pkgconfig

%description -n ephysics-devel
Development files for ephysics.

%package -n ethumb
Summary:	Thumbnail generation library for EFL
License:	LGPLv2+

%description -n ethumb
Ethumb is a thumbnail generation library.

%package -n ethumb-devel
Summary:	Development files for ethumb
Requires:	ethumb%{?_isa} = %{version}-%{release}
Requires:	pkgconfig

%description -n ethumb-devel
Development files for ethumb.

%package -n evas
Summary:	Hardware-accelerated state-aware canvas API
License:	BSD

%description -n evas
Evas is a clean display canvas API for several target display systems
that can draw anti-aliased text, smooth super and sub-sampled scaled
images, alpha-blend objects and much more.

%package -n evas-devel
Summary:	Development files for evas
License:	BSD
Requires:	evas%{?_isa} = %{version}-%{release}
Requires:	pkgconfig
Requires:	libX11-devel

%description -n evas-devel
The evas-devel package contains libraries and header files for
developing applications that use evas.


%prep
%setup -q
%patch0 -p1 -b .tslibfix
autoreconf -ifv

%build
# The arm-wide disablement of neon is not right
# but i'm not sure which targets allow for neon at compile.
%configure \
	--enable-xinput22 \
	--enable-systemd \
	--enable-image-loader-webp \
	--enable-harfbuzz \
	--enable-sdl \
	--enable-scim \
	--enable-fb \
	--enable-wayland \
	--disable-static \
	--with-profile=release \
%ifarch %{arm}
	--disable-neon \
%endif
	--with-systemdunitdir=%{_unitdir}
make %{?_smp_mflags} V=1
# This makes doxygen segfault. :/
# make %{?_smp_mflags} doc V=1

%install
make install DESTDIR=%{buildroot}

# fix perms
chmod -x src/bin/edje/edje_cc_out.c

find %{buildroot} -name '*.la' -exec rm -f {} ';'

%find_lang %{name}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%post -n ecore -p /sbin/ldconfig

%postun -n ecore -p /sbin/ldconfig

%post -n edje -p /sbin/ldconfig

%postun -n edje -p /sbin/ldconfig

%post -n eet -p /sbin/ldconfig

%postun -n eet -p /sbin/ldconfig

%post -n eeze -p /sbin/ldconfig

%postun -n eeze -p /sbin/ldconfig

%post -n efreet
/sbin/ldconfig
%systemd_post efreet.service

%preun -n efreet
%systemd_preun efreet.service

%postun -n efreet 
/sbin/ldconfig
%systemd_postun_with_restart efreet.service 

%post -n eina -p /sbin/ldconfig

%postun -n eina -p /sbin/ldconfig

%post -n eio -p /sbin/ldconfig

%postun -n eio -p /sbin/ldconfig

%post -n eldbus -p /sbin/ldconfig

%postun -n eldbus -p /sbin/ldconfig

%post -n embryo -p /sbin/ldconfig

%postun -n embryo -p /sbin/ldconfig

%post -n emotion -p /sbin/ldconfig

%postun -n emotion -p /sbin/ldconfig

%post -n eo -p /sbin/ldconfig

%postun -n eo -p /sbin/ldconfig

%post -n eolian -p /sbin/ldconfig

%postun -n eolian -p /sbin/ldconfig

%post -n ephysics -p /sbin/ldconfig

%postun -n ephysics -p /sbin/ldconfig

%post -n ethumb
/sbin/ldconfig
%systemd_post ethumb.service

%preun -n ethumb
%systemd_preun ethumb.service

%postun -n ethumb
/sbin/ldconfig
%systemd_postun_with_restart ethumb.service

%post -n evas -p /sbin/ldconfig

%postun -n evas -p /sbin/ldconfig

%files -f %{name}.lang
%{!?_licensedir:%global license %%doc}
%license licenses/COPYING.BSD licenses/COPYING.GPL licenses/COPYING.LGPL licenses/COPYING.SMALL
%doc AUTHORS COPYING COMPLIANCE NEWS README
%{_libdir}/libefl.so.1*

%files devel
%{_includedir}/efl-1/
%{_includedir}/efl-cxx-1/
%{_libdir}/cmake/Efl/
%{_libdir}/libefl.so
%{_libdir}/pkgconfig/efl-cxx.pc
%{_libdir}/pkgconfig/efl.pc

%files -n ecore
%license licenses/COPYING.BSD
%{_bindir}/ecore_evas_convert
%{_libdir}/ecore/ 
%{_libdir}/ecore_evas/
%{_libdir}/ecore_imf/
%{_libdir}/ecore_x/
%{_libdir}/libecore*.so.*
%{_datadir}/ecore/
%{_datadir}/ecore_imf/
%{_datadir}/ecore_x/

%files -n ecore-devel
%{_includedir}/ecore-1/
%{_includedir}/ecore-audio-1/
%{_includedir}/ecore-audio-cxx-1/
%{_includedir}/ecore-avahi-1/
%{_includedir}/ecore-con-1/
%{_includedir}/ecore-cxx-1/
%{_includedir}/ecore-evas-1/
%{_includedir}/ecore-fb-1/
%{_includedir}/ecore-file-1/
%{_includedir}/ecore-imf-1/
%{_includedir}/ecore-imf-evas-1/
%{_includedir}/ecore-input-1/
%{_includedir}/ecore-input-evas-1/
%{_includedir}/ecore-ipc-1/
%{_includedir}/ecore-sdl-1/
%{_includedir}/ecore-wayland-1/
%{_includedir}/ecore-x-1/
%{_libdir}/cmake/Ecore*/*.cmake
%{_libdir}/libecore*.so
%{_libdir}/pkgconfig/ecore*.pc

%files -n edje
%license licenses/COPYING.BSD licenses/COPYING.GPL
%{_bindir}/edje*
%{_datadir}/mime/packages/edje.xml
%{_libdir}/edje/
%{_libdir}/libedje.so.1*

%files -n edje-devel
%{_libdir}/libedje.so
%{_libdir}/pkgconfig/edje*.pc
%{_datadir}/edje
%{_includedir}/edje-*
%{_libdir}/cmake/Edje/

%files -n eet
%license licenses/COPYING.BSD licenses/COPYING.GPL
%{_bindir}/eet
%{_bindir}/vieet
%{_libdir}/libeet.so.*

%files -n eet-devel
%{_includedir}/eet-1/
%{_includedir}/eet-cxx-1/
%{_libdir}/cmake/Eet/*.cmake
%{_libdir}/cmake/EetCxx/*.cmake
%{_libdir}/pkgconfig/eet*.pc
%{_libdir}/libeet.so

%files -n eeze
%license licenses/COPYING.BSD licenses/COPYING.GPL
%{_bindir}/eeze_*
%{_libdir}/eeze/
%{_libdir}/libeeze.so.1*

%files -n eeze-devel
%{_includedir}/eeze-1/
%{_libdir}/cmake/Eeze/
%{_libdir}/libeeze.so
%{_datadir}/eeze/
%{_libdir}/pkgconfig/eeze.pc

%files -n efreet
%{_bindir}/efreetd
%{_unitdir}/efreet.service
%{_datadir}/dbus-1/services/org.enlightenment.Efreet.service
%{_libdir}/efreet/
%{_libdir}/libefreet.so.1*
%{_libdir}/libefreet_mime.so.1*
%{_libdir}/libefreet_trash.so.1*

%files -n efreet-devel
%{_includedir}/efreet-1/
%{_libdir}/cmake/Efreet/
%{_libdir}/libefreet.so
%{_libdir}/libefreet_mime.so
%{_libdir}/libefreet_trash.so
%{_datadir}/efreet/
%{_libdir}/pkgconfig/efreet.pc
%{_libdir}/pkgconfig/efreet-mime.pc
%{_libdir}/pkgconfig/efreet-trash.pc

%files -n eina
%license licenses/COPYING.LGPL
%{_libdir}/libeina.so.*

%files -n eina-devel
%{_bindir}/eina-bench-cmp
%{_includedir}/eina-1/
%{_includedir}/eina-cxx-1/
%{_libdir}/cmake/Eina*/*.cmake
%{_libdir}/pkgconfig/eina*.pc
%{_libdir}/libeina.so

%files -n eio
%license licenses/COPYING.LGPL 
%{_libdir}/libeio.so.1*

%files -n eio-devel
%{_includedir}/eio-1/
%{_libdir}/libeio.so
%{_libdir}/pkgconfig/eio.pc

%files -n eldbus
%license licenses/COPYING.LGPL
%{_bindir}/eldbus-codegen
%{_libdir}/libeldbus.so.1*

%files -n eldbus-devel
%{_includedir}/eldbus-1/
%{_includedir}/eldbus_cxx-1/
%{_libdir}/cmake/Eldbus/
%{_libdir}/libeldbus.so
%{_libdir}/pkgconfig/eldbus.pc

%files -n elua
%license licenses/COPYING.BSD
%{_bindir}/elua
%{_datadir}/elua/

%files -n embryo
%license licenses/COPYING.SMALL
%{_bindir}/embryo_cc
%{_libdir}/libembryo.so.1*

%files -n embryo-devel
%{_includedir}/embryo-1/
%{_libdir}/libembryo.so
%{_libdir}/pkgconfig/embryo.pc
%{_datadir}/embryo/

%files -n emotion
%license licenses/COPYING.BSD licenses/COPYING.GPL
%{_libdir}/emotion/
%{_libdir}/libemotion.so.1*

%files -n emotion-devel
%{_includedir}/emotion-1/
%{_libdir}/cmake/Emotion/
%{_libdir}/libemotion.so
%{_libdir}/pkgconfig/emotion.pc
%{_datadir}/emotion/

%files -n eo
%license licenses/COPYING.BSD
%{_libdir}/libeo.so.1*

%files -n eo-devel
%{_includedir}/eo-1/
%{_includedir}/eo-cxx-1/
%{_libdir}/cmake/Eo/
%{_libdir}/cmake/EoCxx/
%{_libdir}/libeo.so
%{_libdir}/pkgconfig/eo.pc
%{_libdir}/pkgconfig/eo-cxx.pc
%{_datadir}/eo/
%{_datadir}/gdb/auto-load/%{_libdir}/libeo.so*

%files -n eolian
%license licenses/COPYING.BSD
%{_bindir}/eolian_cxx
%{_bindir}/eolian_gen
%{_libdir}/libeolian.so.1*

%files -n eolian-devel
%{_includedir}/eolian-1/
%{_includedir}/eolian-cxx-1/
%{_libdir}/cmake/Eolian/
%{_libdir}/cmake/EolianCxx/
%{_libdir}/pkgconfig/eolian.pc
%{_libdir}/pkgconfig/eolian-cxx.pc
%{_libdir}/libeolian.so
%{_datadir}/eolian/

%files -n ephysics
%license licenses/COPYING.BSD
%{_libdir}/libephysics.so.1*

%files -n ephysics-devel
%{_includedir}/ephysics-1/
%{_libdir}/libephysics.so
%{_libdir}/pkgconfig/ephysics.pc

%files -n ethumb
%license licenses/COPYING.LGPL
%{_bindir}/ethumb
%{_bindir}/ethumbd
%{_bindir}/ethumbd_client
%{_unitdir}/ethumb.service
%{_libdir}/ethumb/
%{_libdir}/ethumb_client/
%{_libdir}/libethumb.so.1*
%{_libdir}/libethumb_client.so.1*
%{_datadir}/dbus-1/services/org.enlightenment.Ethumb.service
%{_datadir}/ethumb
%{_datadir}/ethumb_client

%files -n ethumb-devel
%{_includedir}/ethumb-1/
%{_includedir}/ethumb-client-1/
%{_libdir}/cmake/Ethumb/
%{_libdir}/cmake/EthumbClient/
%{_libdir}/libethumb.so
%{_libdir}/libethumb_client.so
%{_libdir}/pkgconfig/ethumb.pc
%{_libdir}/pkgconfig/ethumb_client.pc

%files -n evas
%{_bindir}/evas_*
%{_libdir}/evas/
%{_libdir}/libevas.so.*
%{_datadir}/evas/

%files -n evas-devel
%{_includedir}/evas-1/
%{_includedir}/evas-cxx-1/
%{_libdir}/libevas.so
%{_libdir}/cmake/Evas/*.cmake
%{_libdir}/cmake/EvasCxx/*.cmake
%{_libdir}/pkgconfig/evas*.pc

%changelog
* Mon Dec 15 2014 Tom Callaway <spot@fedoraproject.org> - 1.12.2-1
- initial package
